<?php
/*
Stallion Popular Posts, Recent Posts and Random Posts Widget 8.1 silo
*/

add_action('widgets_init', 'st_pop_widgets_init');

function st_pop_widgets_init() {
register_widget('st_pop_Widget');
}

class st_pop_widget extends WP_Widget {

function st_pop_Widget() {
$widget_ops = array('classname' => 'st_pop_widget', 'description' => __('Popular, Recent, Random Posts with thumbnails and short excerpts ordered by comments count or randomly etc... with SEO coding and silo options.', 'stallion'));

$this->WP_Widget('st_pop_widget', __('Stallion SEO Posts', 'stallion'), $widget_ops);
}

function widget($args, $instance) {
global $post;
extract($args);
$args = array();

$title = apply_filters('widget_title', $instance['title']);
$poprand = $instance['poprand'];
$ascdes = $instance['ascdes'];
$num = $instance['num'];
$showtlink = $instance['showtlink'];
$showtlink_ct = $instance['showtlink_ct'];
$aioseolinkpri = $instance['aioseolinkpri'];
$showimage = $instance['showimage'];
$showimage_ct = $instance['showimage_ct'];
$randthumb = $instance['randthumb'];
$imagetype = $instance['imagetype'];
$randthumbset = $instance['randthumbset'];
$randthumbqual = $instance['randthumbqual'];
$aioseoaltpri = $instance['aioseoaltpri'];
$size = $instance['size'];
$size2 = $instance['size2'];
$align = $instance['align'];
$showexcerpt = $instance['showexcerpt'];
$showexcerpt_ct = $instance['showexcerpt_ct'];
$showexcerptsz = $instance['showexcerptsz'];
$onlycheck = $instance['onlycheck'];

$include = '';

if ($onlycheck == 'siloauto' && is_single()) :
#echo 'siloauto single';
$categories = get_the_category();
if ($categories) :
foreach($categories as $category) {
$include .= $category->cat_ID .', ';
}
endif;

elseif ($onlycheck == 'siloauto' && is_category() ) :
#echo 'siloauto category';
global $cat;
$include = $cat;

elseif ($onlycheck == 'siloauto') :
#echo 'siloauto not single or category';
$include = '';

elseif ($onlycheck != 'siloauto' && $onlycheck != 'checked') :
$args['include'] = ( isset($instance['include']) ? join(', ', $instance['include']) : '' );
$include = $args['include'];

else :
endif;
#echo $include;

echo $before_widget;

if ($title)
echo $before_title . $title . $after_title;

if ($num)
if ($onlycheck == 'checked') :
$popular = new WP_Query('ignore_sticky_posts=1&orderby=' . $poprand . '&order=' . $ascdes . '&posts_per_page=' . $num);
endif;

if ($onlycheck != 'checked') :
$popular = new WP_Query('cat=' . $include . '&ignore_sticky_posts=1&orderby=' . $poprand . '&order=' . $ascdes . '&posts_per_page=' . $num);
endif;

#show image start
if ($showimage == 'checked') :
echo '<ul class="stallionseocomments">';
else :
echo '<ul class="stallionpostswidget">';
endif;

$count = 0;
while ($popular->have_posts()) : $popular->the_post();
$count++;
if ($showexcerpt == 'checked') :
echo '
<li class="stallionseocomments2">';
else :
echo '
<li class="stallionpostswidget">';
endif;

if ($showimage == 'checked' && $count <= $showimage_ct) :
if ($aioseoaltpri == '_aioseop_none'):
$st_seoimtitle = get_the_title();

elseif ($aioseoaltpri == '_aioseop_panda1') :

if (is_home() || is_front_page()) :
if ((st_seo_data() == '1' || function_exists('aioseop_mrt_mkarry')) && get_post_meta($post->ID, '_aioseop_title', true)) :
$st_seoimtitle = get_post_meta($post->ID, '_aioseop_title', true);
elseif ((st_seo_data() == '2' || function_exists('wpseo_init')) && get_post_meta($post->ID, '_yoast_wpseo_title', true)) :
$st_seoimtitle = get_post_meta($post->ID, '_yoast_wpseo_title', true);
else :
$st_seoimtitle = get_the_title();
endif;

elseif (is_single() & !is_front_page()) :
if (get_post_meta($post->ID, '_aioseop_kw_1', true)) :
$st_seoimtitle = get_post_meta($post->ID, '_aioseop_kw_1', true);
else :
$st_seoimtitle = get_the_title();
endif;

elseif (is_page() & !is_front_page()) :
if (get_post_meta($post->ID, '_aioseop_kw_2', true)) :
$st_seoimtitle = get_post_meta($post->ID, '_aioseop_kw_2', true);
else :
$st_seoimtitle = get_the_title();
endif;

elseif (is_category()) :
if (get_post_meta($post->ID, '_aioseop_kw_3', true)) :
$st_seoimtitle = get_post_meta($post->ID, '_aioseop_kw_3', true);
else :
$st_seoimtitle = get_the_title();
endif;

elseif (is_tag() || is_404()) :
if (get_post_meta($post->ID, '_aioseop_kw_4', true)) :
$st_seoimtitle = get_post_meta($post->ID, '_aioseop_kw_4', true);
else :
$st_seoimtitle = get_the_title();
endif;

elseif (is_search() || is_year() || is_month() || is_day() || is_author()) :
$st_seoimtitle = get_the_title();

else :
$st_seoimtitle = get_the_title();
endif;

elseif ($aioseoaltpri == '_aioseop_panda2') :

if (is_home() || is_front_page()) :
if (get_post_meta($post->ID, '_aioseop_kw_1', true)) :
$st_seoimtitle = get_post_meta($post->ID, '_aioseop_kw_1', true);
else :
$st_seoimtitle = get_the_title();
endif;

elseif (is_single() & !is_front_page()) :
if ((st_seo_data() == '1' || function_exists('aioseop_mrt_mkarry')) && get_post_meta($post->ID, '_aioseop_title', true)) :
$st_seoimtitle = get_post_meta($post->ID, '_aioseop_title', true);
elseif ((st_seo_data() == '2' || function_exists('wpseo_init')) && get_post_meta($post->ID, '_yoast_wpseo_title', true)) :
$st_seoimtitle = get_post_meta($post->ID, '_yoast_wpseo_title', true);
else :
$st_seoimtitle = get_the_title();
endif;

elseif (is_page() & !is_front_page()) :
if (get_post_meta($post->ID, '_aioseop_kw_3', true)) :
$st_seoimtitle = get_post_meta($post->ID, '_aioseop_kw_3', true);
else :
$st_seoimtitle = get_the_title();
endif;

elseif (is_category()) :
if (get_post_meta($post->ID, '_aioseop_kw_4', true)) :
$st_seoimtitle = get_post_meta($post->ID, '_aioseop_kw_4', true);
else :
$st_seoimtitle = get_the_title();
endif;

elseif (is_tag() || is_404()) :
$st_seoimtitle = get_the_title();

elseif (is_search() || is_year() || is_month() || is_day() || is_author()) :
if (get_post_meta($post->ID, '_aioseop_kw_2', true)) :
$st_seoimtitle = get_post_meta($post->ID, '_aioseop_kw_2', true);
else :
$st_seoimtitle = get_the_title();
endif;

else :
$st_seoimtitle = get_the_title();
endif;

elseif ($aioseoaltpri == '_aioseop_panda3') :

if (is_home() || is_front_page()) :
if (get_post_meta($post->ID, '_aioseop_kw_2', true)) :
$st_seoimtitle = get_post_meta($post->ID, '_aioseop_kw_2', true);
else :
$st_seoimtitle = get_the_title();
endif;

elseif (is_single() & !is_front_page()) :
if (get_post_meta($post->ID, '_aioseop_kw_4', true)) :
$st_seoimtitle = get_post_meta($post->ID, '_aioseop_kw_4', true);
else :
$st_seoimtitle = get_the_title();
endif;

elseif (is_page() & !is_front_page()) :
if ((st_seo_data() == '1' || function_exists('aioseop_mrt_mkarry')) && get_post_meta($post->ID, '_aioseop_title', true)) :
$st_seoimtitle = get_post_meta($post->ID, '_aioseop_title', true);
elseif ((st_seo_data() == '2' || function_exists('wpseo_init')) && get_post_meta($post->ID, '_yoast_wpseo_title', true)) :
$st_seoimtitle = get_post_meta($post->ID, '_yoast_wpseo_title', true);
else :
$st_seoimtitle = get_the_title();
endif;

elseif (is_category()) :
$st_seoimtitle = get_the_title();

elseif (is_tag() || is_404()) :
if (get_post_meta($post->ID, '_aioseop_kw_3', true)) :
$st_seoimtitle = get_post_meta($post->ID, '_aioseop_kw_3', true);
else :
$st_seoimtitle = get_the_title();
endif;

elseif (is_search() || is_year() || is_month() || is_day() || is_author()) :
if (get_post_meta($post->ID, '_aioseop_kw_1', true)) :
$st_seoimtitle = get_post_meta($post->ID, '_aioseop_kw_1', true);
else :
$st_seoimtitle = get_the_title();
endif;

else :
$st_seoimtitle = get_the_title();
endif;

elseif ($aioseoaltpri == '_aioseop_panda4') :

if (is_home() || is_front_page()) :
if (get_post_meta($post->ID, '_aioseop_kw_3', true)) :
$st_seoimtitle = get_post_meta($post->ID, '_aioseop_kw_3', true);
else :
$st_seoimtitle = get_the_title();
endif;

elseif (is_single() & !is_front_page()) :
if (get_post_meta($post->ID, '_aioseop_kw_2', true)) :
$st_seoimtitle = get_post_meta($post->ID, '_aioseop_kw_2', true);
else :
$st_seoimtitle = get_the_title();
endif;

elseif (is_page() & !is_front_page()) :
$st_seoimtitle = get_the_title();

elseif (is_category()) :
if (get_post_meta($post->ID, '_aioseop_kw_1', true)) :
$st_seoimtitle = get_post_meta($post->ID, '_aioseop_kw_1', true);
else :
$st_seoimtitle = get_the_title();
endif;

elseif (is_tag() || is_404()) :
if ((st_seo_data() == '1' || function_exists('aioseop_mrt_mkarry')) && get_post_meta($post->ID, '_aioseop_title', true)) :
$st_seoimtitle = get_post_meta($post->ID, '_aioseop_title', true);
elseif ((st_seo_data() == '2' || function_exists('wpseo_init')) && get_post_meta($post->ID, '_yoast_wpseo_title', true)) :
$st_seoimtitle = get_post_meta($post->ID, '_yoast_wpseo_title', true);
else :
$st_seoimtitle = get_the_title();
endif;

elseif (is_search() || is_year() || is_month() || is_day() || is_author()) :
if (get_post_meta($post->ID, '_aioseop_kw_4', true)) :
$st_seoimtitle = get_post_meta($post->ID, '_aioseop_kw_4', true);
else :
$st_seoimtitle = get_the_title();
endif;

else :
$st_seoimtitle = get_the_title();
endif;

elseif ($aioseoaltpri == '_aioseop_panda5') :

if (is_home() || is_front_page()) :
if (get_post_meta($post->ID, '_aioseop_kw_4', true)) :
$st_seoimtitle = get_post_meta($post->ID, '_aioseop_kw_4', true);
else :
$st_seoimtitle = get_the_title();
endif;

elseif (is_single() & !is_front_page()) :
$st_seoimtitle = get_the_title();

elseif (is_page() & !is_front_page()) :
if (get_post_meta($post->ID, '_aioseop_kw_1', true)) :
$st_seoimtitle = get_post_meta($post->ID, '_aioseop_kw_1', true);
else :
$st_seoimtitle = get_the_title();
endif;

elseif (is_category()) :
if ((st_seo_data() == '1' || function_exists('aioseop_mrt_mkarry')) && get_post_meta($post->ID, '_aioseop_title', true)) :
$st_seoimtitle = get_post_meta($post->ID, '_aioseop_title', true);
elseif ((st_seo_data() == '2' || function_exists('wpseo_init')) && get_post_meta($post->ID, '_yoast_wpseo_title', true)) :
$st_seoimtitle = get_post_meta($post->ID, '_yoast_wpseo_title', true);
else :
$st_seoimtitle = get_the_title();
endif;

elseif (is_tag() || is_404()) :
if (get_post_meta($post->ID, '_aioseop_kw_2', true)) :
$st_seoimtitle = get_post_meta($post->ID, '_aioseop_kw_2', true);
else :
$st_seoimtitle = get_the_title();
endif;

elseif (is_search() || is_year() || is_month() || is_day() || is_author()) :
if (get_post_meta($post->ID, '_aioseop_kw_3', true)) :
$st_seoimtitle = get_post_meta($post->ID, '_aioseop_kw_3', true);
else :
$st_seoimtitle = get_the_title();
endif;

else :
$st_seoimtitle = get_the_title();
endif;

elseif ($aioseoaltpri == '_aioseop_panda6') :

if (is_home() || is_front_page()) :
$st_seoimtitle = get_the_title();

elseif (is_single() & !is_front_page()) :
if (get_post_meta($post->ID, '_aioseop_kw_3', true)) :
$st_seoimtitle = get_post_meta($post->ID, '_aioseop_kw_3', true);
else :
$st_seoimtitle = get_the_title();
endif;

elseif (is_page() & !is_front_page()) :
if ((st_seo_data() == '1' || function_exists('aioseop_mrt_mkarry')) && get_post_meta($post->ID, '_aioseop_title', true)) :
$st_seoimtitle = get_post_meta($post->ID, '_aioseop_title', true);
elseif ((st_seo_data() == '2' || function_exists('wpseo_init')) && get_post_meta($post->ID, '_yoast_wpseo_title', true)) :
$st_seoimtitle = get_post_meta($post->ID, '_yoast_wpseo_title', true);
else :
$st_seoimtitle = get_the_title();
endif;

elseif (is_category()) :
if (get_post_meta($post->ID, '_aioseop_kw_2', true)) :
$st_seoimtitle = get_post_meta($post->ID, '_aioseop_kw_2', true);
else :
$st_seoimtitle = get_the_title();
endif;

elseif (is_tag() || is_404()) :
if (get_post_meta($post->ID, '_aioseop_kw_4', true)) :
$st_seoimtitle = get_post_meta($post->ID, '_aioseop_kw_1', true);
else :
$st_seoimtitle = get_the_title();
endif;

elseif (is_search() || is_year() || is_month() || is_day() || is_author()) :
if (get_post_meta($post->ID, '_aioseop_kw_1', true)) :
$st_seoimtitle = get_post_meta($post->ID, '_aioseop_kw_4', true);
else :
$st_seoimtitle = get_the_title();
endif;

else :
$st_seoimtitle = get_the_title();
endif;

elseif (get_post_meta($post->ID, $aioseoaltpri, true)):
$st_seoimtitle = get_post_meta($post->ID, $aioseoaltpri, true);

elseif ((st_seo_data() == '1' || function_exists('aioseop_mrt_mkarry')) && get_post_meta($post->ID, '_aioseop_title', true)):
$st_seoimtitle = get_post_meta($post->ID, '_aioseop_title', true);

elseif ((st_seo_data() == '2' || function_exists('wpseo_init')) && get_post_meta($post->ID, '_yoast_wpseo_title', true)) :
$st_seoimtitle = get_post_meta($post->ID, '_yoast_wpseo_title', true);

else :
$st_seoimtitle = get_the_title();
endif;

if ($align == 'center') {
echo '<p class="align-center">';
}

echo '<a href="' . get_permalink(get_the_ID());
if (st_seo_plus() == '1') {
echo '#img_' . $poprand;
}
echo '">';

if (has_post_thumbnail() && !is_multisite()) :
$img_src1 = wp_get_attachment_image_src(get_post_thumbnail_id(), 'full');
$imageurl = $img_src1[0];

if (file_exists(STYLESHEETPATH . '/timthumb.php')) {
$st_template_url = get_bloginfo('stylesheet_directory');
} else {
$st_template_url = get_bloginfo('template_url');
}

echo '<img class="float' . $align . '" src="' . $st_template_url . '/timthumb.php?src=' . $imageurl . '&amp;w=' . $size . '&amp;h=' . $size2 . '&amp;q=' . $randthumbqual . '" width="' . $size . '" height="' . $size2 . '" alt="' . $st_seoimtitle . '" />'; elseif ($st_ft_thumb = get_image_path(get_post_meta(get_the_ID(), 'thumb', true))):
if (file_exists(STYLESHEETPATH . '/timthumb.php')) {
$st_template_url = get_bloginfo('stylesheet_directory');
} else {
$st_template_url = get_bloginfo('template_url');
}
echo '<img class="float' . $align . '" src="' . $st_template_url . '/timthumb.php?src=' . $st_ft_thumb . '&amp;w=' . $size . '&amp;h=' . $size2 . '&amp;q=' . $randthumbqual . '" width="' . $size . '" height="' . $size2 . '" alt="' . $st_seoimtitle . '" />';

else :
if (file_exists(STYLESHEETPATH . '/timthumb.php')) {
$st_template_url = get_bloginfo('stylesheet_directory');
} else {
$st_template_url = get_bloginfo('template_url');
}
echo '<img class="float' . $align . '" src="' . $st_template_url . '/timthumb.php?src=';

if (file_exists(STYLESHEETPATH . '/thumbnails/' . $randthumbset . '/1.' . $imagetype . '')) {
if (is_multisite()) {
$imageurlthumb = get_site_url(1) . '/wp-content/themes/' . get_option('stylesheet');
} else {
$imageurlthumb = get_bloginfo('stylesheet_directory');
}
} else {
if (is_multisite()) {
$imageurlthumb = get_site_url(1) . '/wp-content/themes/' . get_option('template');
} else {
$imageurlthumb = bloginfo('template_url');
}
}
echo $imageurlthumb . '/thumbnails/' . $randthumbset . '/' . mt_rand(1, $randthumb) . '.' . $imagetype . '&amp;w=' . $size . '&amp;h=' . $size2 . '&amp;q=' . $randthumbqual . '" width="' . $size . '" height="' . $size2 . '" alt="' . $st_seoimtitle . '" />';
endif;

echo '</a>';

if ($align == 'center') {
echo '</p>';
}

endif;
#show image end

#show link start
if ($showtlink == 'checked' && $count <= $showtlink_ct) :
if ($aioseolinkpri == '_aioseop_none'):
$st_seotitle = get_the_title();

elseif ($aioseolinkpri == '_aioseop_panda1') :

if (is_home() || is_front_page()) :
if ((st_seo_data() == '1' || function_exists('aioseop_mrt_mkarry')) && get_post_meta($post->ID, '_aioseop_title', true)) :
$st_seotitle = get_post_meta($post->ID, '_aioseop_title', true);
elseif ((st_seo_data() == '2' || function_exists('wpseo_init')) && get_post_meta($post->ID, '_yoast_wpseo_title', true)) :
$st_seotitle = get_post_meta($post->ID, '_yoast_wpseo_title', true);
else :
$st_seotitle = get_the_title();
endif;

elseif (is_single() & !is_front_page()) :
if (get_post_meta($post->ID, '_aioseop_kw_1', true)) :
$st_seotitle = get_post_meta($post->ID, '_aioseop_kw_1', true);
else :
$st_seotitle = get_the_title();
endif;

elseif (is_page() & !is_front_page()) :
if (get_post_meta($post->ID, '_aioseop_kw_2', true)) :
$st_seotitle = get_post_meta($post->ID, '_aioseop_kw_2', true);
else :
$st_seotitle = get_the_title();
endif;

elseif (is_category()) :
if (get_post_meta($post->ID, '_aioseop_kw_3', true)) :
$st_seotitle = get_post_meta($post->ID, '_aioseop_kw_3', true);
else :
$st_seotitle = get_the_title();
endif;

elseif (is_tag() || is_404()) :
if (get_post_meta($post->ID, '_aioseop_kw_4', true)) :
$st_seotitle = get_post_meta($post->ID, '_aioseop_kw_4', true);
else :
$st_seotitle = get_the_title();
endif;

elseif (is_search() || is_year() || is_month() || is_day() || is_author()) :
$st_seotitle = get_the_title();

else :
$st_seotitle = get_the_title();
endif;

elseif ($aioseolinkpri == '_aioseop_panda2') :

if (is_home() || is_front_page()) :
if (get_post_meta($post->ID, '_aioseop_kw_1', true)) :
$st_seotitle = get_post_meta($post->ID, '_aioseop_kw_1', true);
else :
$st_seotitle = get_the_title();
endif;

elseif (is_single() & !is_front_page()) :
if ((st_seo_data() == '1' || function_exists('aioseop_mrt_mkarry')) && get_post_meta($post->ID, '_aioseop_title', true)) :
$st_seotitle = get_post_meta($post->ID, '_aioseop_title', true);
elseif ((st_seo_data() == '2' || function_exists('wpseo_init')) && get_post_meta($post->ID, '_yoast_wpseo_title', true)) :
$st_seotitle = get_post_meta($post->ID, '_yoast_wpseo_title', true);
else :
$st_seotitle = get_the_title();
endif;

elseif (is_page() & !is_front_page()) :
if (get_post_meta($post->ID, '_aioseop_kw_3', true)) :
$st_seotitle = get_post_meta($post->ID, '_aioseop_kw_3', true);
else :
$st_seotitle = get_the_title();
endif;

elseif (is_category()) :
if (get_post_meta($post->ID, '_aioseop_kw_4', true)) :
$st_seotitle = get_post_meta($post->ID, '_aioseop_kw_4', true);
else :
$st_seotitle = get_the_title();
endif;

elseif (is_tag() || is_404()) :
$st_seotitle = get_the_title();

elseif (is_search() || is_year() || is_month() || is_day() || is_author()) :
if (get_post_meta($post->ID, '_aioseop_kw_2', true)) :
$st_seotitle = get_post_meta($post->ID, '_aioseop_kw_2', true);
else :
$st_seotitle = get_the_title();
endif;

else :
$st_seotitle = get_the_title();
endif;

elseif ($aioseolinkpri == '_aioseop_panda3') :

if (is_home() || is_front_page()) :
if (get_post_meta($post->ID, '_aioseop_kw_2', true)) :
$st_seotitle = get_post_meta($post->ID, '_aioseop_kw_2', true);
else :
$st_seotitle = get_the_title();
endif;

elseif (is_single() & !is_front_page()) :
if (get_post_meta($post->ID, '_aioseop_kw_4', true)) :
$st_seotitle = get_post_meta($post->ID, '_aioseop_kw_4', true);
else :
$st_seotitle = get_the_title();
endif;

elseif (is_page() & !is_front_page()) :
if ((st_seo_data() == '1' || function_exists('aioseop_mrt_mkarry')) && get_post_meta($post->ID, '_aioseop_title', true)) :
$st_seotitle = get_post_meta($post->ID, '_aioseop_title', true);
elseif ((st_seo_data() == '2' || function_exists('wpseo_init')) && get_post_meta($post->ID, '_yoast_wpseo_title', true)) :
$st_seotitle = get_post_meta($post->ID, '_yoast_wpseo_title', true);
else :
$st_seotitle = get_the_title();
endif;

elseif (is_category()) :
$st_seotitle = get_the_title();

elseif (is_tag() || is_404()) :
if (get_post_meta($post->ID, '_aioseop_kw_3', true)) :
$st_seotitle = get_post_meta($post->ID, '_aioseop_kw_3', true);
else :
$st_seotitle = get_the_title();
endif;

elseif (is_search() || is_year() || is_month() || is_day() || is_author()) :
if (get_post_meta($post->ID, '_aioseop_kw_1', true)) :
$st_seotitle = get_post_meta($post->ID, '_aioseop_kw_1', true);
else :
$st_seotitle = get_the_title();
endif;

else :
$st_seotitle = get_the_title();
endif;

elseif ($aioseolinkpri == '_aioseop_panda4') :

if (is_home() || is_front_page()) :
if (get_post_meta($post->ID, '_aioseop_kw_3', true)) :
$st_seotitle = get_post_meta($post->ID, '_aioseop_kw_3', true);
else :
$st_seotitle = get_the_title();
endif;

elseif (is_single() & !is_front_page()) :
if (get_post_meta($post->ID, '_aioseop_kw_2', true)) :
$st_seotitle = get_post_meta($post->ID, '_aioseop_kw_2', true);
else :
$st_seotitle = get_the_title();
endif;

elseif (is_page() & !is_front_page()) :
$st_seotitle = get_the_title();

elseif (is_category()) :
if (get_post_meta($post->ID, '_aioseop_kw_1', true)) :
$st_seotitle = get_post_meta($post->ID, '_aioseop_kw_1', true);
else :
$st_seotitle = get_the_title();
endif;

elseif (is_tag() || is_404()) :
if ((st_seo_data() == '1' || function_exists('aioseop_mrt_mkarry')) && get_post_meta($post->ID, '_aioseop_title', true)) :
$st_seotitle = get_post_meta($post->ID, '_aioseop_title', true);
elseif ((st_seo_data() == '2' || function_exists('wpseo_init')) && get_post_meta($post->ID, '_yoast_wpseo_title', true)) :
$st_seotitle = get_post_meta($post->ID, '_yoast_wpseo_title', true);
else :
$st_seotitle = get_the_title();
endif;

elseif (is_search() || is_year() || is_month() || is_day() || is_author()) :
if (get_post_meta($post->ID, '_aioseop_kw_4', true)) :
$st_seotitle = get_post_meta($post->ID, '_aioseop_kw_4', true);
else :
$st_seotitle = get_the_title();
endif;

else :
$st_seotitle = get_the_title();
endif;

elseif ($aioseolinkpri == '_aioseop_panda5') :

if (is_home() || is_front_page()) :
if (get_post_meta($post->ID, '_aioseop_kw_4', true)) :
$st_seotitle = get_post_meta($post->ID, '_aioseop_kw_4', true);
else :
$st_seotitle = get_the_title();
endif;

elseif (is_single() & !is_front_page()) :
$st_seotitle = get_the_title();

elseif (is_page() & !is_front_page()) :
if (get_post_meta($post->ID, '_aioseop_kw_1', true)) :
$st_seotitle = get_post_meta($post->ID, '_aioseop_kw_1', true);
else :
$st_seotitle = get_the_title();
endif;

elseif (is_category()) :
if ((st_seo_data() == '1' || function_exists('aioseop_mrt_mkarry')) && get_post_meta($post->ID, '_aioseop_title', true)) :
$st_seotitle = get_post_meta($post->ID, '_aioseop_title', true);
elseif ((st_seo_data() == '2' || function_exists('wpseo_init')) && get_post_meta($post->ID, '_yoast_wpseo_title', true)) :
$st_seotitle = get_post_meta($post->ID, '_yoast_wpseo_title', true);
else :
$st_seotitle = get_the_title();
endif;

elseif (is_tag() || is_404()) :
if (get_post_meta($post->ID, '_aioseop_kw_2', true)) :
$st_seotitle = get_post_meta($post->ID, '_aioseop_kw_2', true);
else :
$st_seotitle = get_the_title();
endif;

elseif (is_search() || is_year() || is_month() || is_day() || is_author()) :
if (get_post_meta($post->ID, '_aioseop_kw_3', true)) :
$st_seotitle = get_post_meta($post->ID, '_aioseop_kw_3', true);
else :
$st_seotitle = get_the_title();
endif;

else :
$st_seotitle = get_the_title();
endif;

elseif ($aioseolinkpri == '_aioseop_panda6') :

if (is_home() || is_front_page()) :
$st_seotitle = get_the_title();

elseif (is_single() & !is_front_page()) :
if (get_post_meta($post->ID, '_aioseop_kw_3', true)) :
$st_seotitle = get_post_meta($post->ID, '_aioseop_kw_3', true);
else :
$st_seotitle = get_the_title();
endif;

elseif (is_page() & !is_front_page()) :
if ((st_seo_data() == '1' || function_exists('aioseop_mrt_mkarry')) && get_post_meta($post->ID, '_aioseop_title', true)) :
$st_seotitle = get_post_meta($post->ID, '_aioseop_title', true);
elseif ((st_seo_data() == '2' || function_exists('wpseo_init')) && get_post_meta($post->ID, '_yoast_wpseo_title', true)) :
$st_seotitle = get_post_meta($post->ID, '_yoast_wpseo_title', true);
else :
$st_seotitle = get_the_title();
endif;

elseif (is_category()) :
if (get_post_meta($post->ID, '_aioseop_kw_2', true)) :
$st_seotitle = get_post_meta($post->ID, '_aioseop_kw_2', true);
else :
$st_seotitle = get_the_title();
endif;

elseif (is_tag() || is_404()) :
if (get_post_meta($post->ID, '_aioseop_kw_4', true)) :
$st_seotitle = get_post_meta($post->ID, '_aioseop_kw_1', true);
else :
$st_seotitle = get_the_title();
endif;

elseif (is_search() || is_year() || is_month() || is_day() || is_author()) :
if (get_post_meta($post->ID, '_aioseop_kw_1', true)) :
$st_seotitle = get_post_meta($post->ID, '_aioseop_kw_4', true);
else :
$st_seotitle = get_the_title();
endif;

else :
$st_seotitle = get_the_title();
endif;

elseif (st_seo_data() == '0' && $aioseolinkpri != '_aioseop_title' && get_post_meta($post->ID, $aioseolinkpri, true)):
$st_seotitle = get_post_meta($post->ID, $aioseolinkpri, true);

elseif ((st_seo_data() == '1' || function_exists('aioseop_mrt_mkarry')) && get_post_meta($post->ID, '_aioseop_title', true)):
$st_seotitle = get_post_meta($post->ID, '_aioseop_title', true);

elseif ((st_seo_data() == '2' || function_exists('wpseo_init')) && get_post_meta($post->ID, '_yoast_wpseo_title', true)) :
$st_seotitle = get_post_meta($post->ID, '_yoast_wpseo_title', true);

else :
$st_seotitle = get_the_title();
endif;

echo '<a href="' . get_permalink(get_the_ID());
if (st_seo_plus() == '1') {
echo '#text_' . $poprand;
}
echo '" title="' . $st_seotitle . '">' . $st_seotitle . '</a>';
endif;
#show link end

#show excerpt start
if ($showexcerpt == 'checked' && $count <= $showexcerpt_ct) :
echo '<br />&raquo; ';
$exxxx = strip_tags(get_the_excerpt());
$exxxx = apply_filters('wptexturize', $exxxx);
$exxxx = apply_filters('convert_chars', $exxxx);
$length = $showexcerptsz;
$words = explode(' ', $exxxx, $length + 1);
if (count($words) > $length) {
array_pop($words);
$exxxx = implode(' ', $words);
}
echo ucfirst($exxxx) . '...';
endif;
#show excerpt end
echo '</li>
';
endwhile;
echo '<div class="clear"></div></ul>';

echo $after_widget;
wp_reset_postdata();
}

function update($new_instance, $old_instance) {
$instance = $old_instance;
$instance['title'] = strip_tags($new_instance['title']);
$instance['poprand'] = $new_instance['poprand'];
$instance['ascdes'] = $new_instance['ascdes'];
$instance['num'] = strip_tags($new_instance['num']);
$instance['showtlink'] = $new_instance['showtlink'];
$instance['showtlink_ct'] = strip_tags($new_instance['showtlink_ct']);
$instance['aioseolinkpri'] = $new_instance['aioseolinkpri'];
$instance['showimage'] = $new_instance['showimage'];
$instance['showimage_ct'] = strip_tags($new_instance['showimage_ct']);
$instance['randthumb'] = $new_instance['randthumb'];
$instance['imagetype'] = $new_instance['imagetype'];
$instance['randthumbset'] = $new_instance['randthumbset'];
$instance['randthumbqual'] = strip_tags($new_instance['randthumbqual']);
$instance['aioseoaltpri'] = $new_instance['aioseoaltpri'];
$instance['size'] = strip_tags($new_instance['size']);
$instance['size2'] = strip_tags($new_instance['size2']);
$instance['align'] = $new_instance['align'];
$instance['showexcerpt'] = $new_instance['showexcerpt'];
$instance['showexcerpt_ct'] = strip_tags($new_instance['showexcerpt_ct']);
$instance['showexcerptsz'] = $new_instance['showexcerptsz'];
$instance['onlycheck'] = $new_instance['onlycheck'];
$instance['include'] = $new_instance['include'];
return $instance;
}

function form($instance) {
$defaults = array(
'title' => '',
'poprand' => 'comment_count',
'ascdes' => 'DESC',
'num' => '5',
'showtlink' => 'checked',
'showtlink_ct' => '5',
'aioseolinkpri' => '_aioseop_none',
'showimage' => 'checked',
'showimage_ct' => '5',
'randthumb' => '10',
'imagetype' => 'jpg',
'randthumbset' => '01-default',
'randthumbqual' => '85',
'aioseoaltpri' => '_aioseop_none',
'size' => '50',
'size2' => '50',
'align' => 'left',
'showexcerpt' => 'checked',
'showexcerpt_ct' => '5',
'showexcerptsz' => '10',
'onlycheck' => 'checked',
'include' => array(),
);
$instance = wp_parse_args((array) $instance, $defaults);
$terms = get_terms('category');
?>

<p><a href="http://stallion-theme.co.uk/stallion-responsive-wordpress-seo-posts-widget/" target="_blank">SEO Posts Widget Tutorial</a></p>

<p>
<label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title:', 'stallion') ?></label>
<input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" value="<?php echo $instance['title']; ?>" />
</p>

<p>
<label for="<?php echo $this->get_field_id('poprand'); ?>"><?php _e('Type of Posts', 'stallion') ?></label>
<select id="<?php echo $this->get_field_id('poprand'); ?>" name="<?php echo $this->get_field_name('poprand'); ?>" class="widefat" style="width:100%;">
<option value="comment_count" <?php if ('comment_count' == $instance['poprand']) {
echo "selected='selected'";
} ?>><?php _e('Popular Posts', 'stallion'); ?></option>
<option value="date" <?php if ('date' == $instance['poprand']) {
echo "selected='selected'";
} ?>><?php _e('Recent Posts', 'stallion'); ?></option>
<option value="modified" <?php if ('modified' == $instance['poprand']) {
echo "selected='selected'";
} ?>><?php _e('Recently Modified Posts', 'stallion'); ?></option>
<option value="rand" <?php if ('rand' == $instance['poprand']) {
echo "selected='selected'";
} ?>><?php _e('Random Posts', 'stallion'); ?></option>
<option value="title" <?php if ('title' == $instance['poprand']) {
echo "selected='selected'";
} ?>><?php _e('Reverse Alphabetical Posts', 'stallion'); ?></option>
<option value="ID" <?php if ('ID' == $instance['poprand']) {
echo "selected='selected'";
} ?>><?php _e('Highest Post ID', 'stallion'); ?></option>
</select></p>

<p>
<label for="<?php echo $this->get_field_id('ascdes'); ?>"><?php _e('Order of Posts', 'stallion') ?></label>
<select id="<?php echo $this->get_field_id('ascdes'); ?>" name="<?php echo $this->get_field_name('ascdes'); ?>" class="widefat" style="width:100%;">
<option value="DESC" <?php if ('DESC' == $instance['ascdes']) {
echo "selected='selected'";
} ?>><?php _e('Default Order', 'stallion'); ?></option>
<option value="ASC" <?php if ('ASC' == $instance['ascdes']) {
echo "selected='selected'";
} ?>><?php _e('Reverse Order', 'stallion'); ?></option>
</select></p>

<p>
<label for="<?php echo $this->get_field_id('num'); ?>"><?php _e('Number of Posts', 'stallion') ?></label>
<input class="widefat" id="<?php echo $this->get_field_id('num'); ?>" name="<?php echo $this->get_field_name('num'); ?>" value="<?php echo $instance['num']; ?>" />
</p>

<p>
<input type="checkbox" name="<?php echo $this->get_field_name('showtlink'); ?>" value="checked" <?php echo $instance['showtlink']; ?> />
<label for="<?php echo $this->get_field_name('showtlink'); ?>"><?php _e('Show Text Link', 'stallion'); ?></label>
</p>

<p>
<label for="<?php echo $this->get_field_id('showtlink_ct'); ?>"><?php _e('Number of Text Links', 'stallion') ?></label>
<input class="widefat" id="<?php echo $this->get_field_id('showtlink_ct'); ?>" name="<?php echo $this->get_field_name('showtlink_ct'); ?>" value="<?php echo $instance['showtlink_ct']; ?>" />
<br /><?php _e('If you set the Number of Posts to 5 and want the first two to show a text links, set to 2.', 'stallion') ?>
</p>

<p>
<label for="<?php echo $this->get_field_id('aioseolinkpri'); ?>"><?php _e('Link Anchor Text AIOSEO Priority', 'stallion') ?></label>
<select id="<?php echo $this->get_field_id('aioseolinkpri'); ?>" name="<?php echo $this->get_field_name('aioseolinkpri'); ?>" class="widefat" style="width:100%;">
<option value="_aioseop_none" <?php if ('_aioseop_none' == $instance['aioseolinkpri']) {
echo "selected='selected'";
} ?>><?php _e('Original Post Title Tag', 'stallion'); ?></option>
<option value="_aioseop_title" <?php if ('_aioseop_title' == $instance['aioseolinkpri']) {
echo "selected='selected'";
} ?>><?php _e('All In One SEO or Yoast SEO Title Tag', 'stallion'); ?></option>
<option value="_aioseop_kw_1" <?php if ('_aioseop_kw_1' == $instance['aioseolinkpri']) {
echo "selected='selected'";
} ?>><?php _e('All In One SEO Related Keyphrase 1', 'stallion'); ?></option>
<option value="_aioseop_kw_2" <?php if ('_aioseop_kw_2' == $instance['aioseolinkpri']) {
echo "selected='selected'";
} ?>><?php _e('All In One SEO Related Keyphrase 2', 'stallion'); ?></option>
<option value="_aioseop_kw_3" <?php if ('_aioseop_kw_3' == $instance['aioseolinkpri']) {
echo "selected='selected'";
} ?>><?php _e('All In One SEO Related Keyphrase 3', 'stallion'); ?></option>
<option value="_aioseop_kw_4" <?php if ('_aioseop_kw_4' == $instance['aioseolinkpri']) {
echo "selected='selected'";
} ?>><?php _e('All In One SEO Related Keyphrase 4', 'stallion'); ?></option>
<option value="_aioseop_panda1" <?php if ('_aioseop_panda1' == $instance['aioseolinkpri']) {
echo "selected='selected'";
} ?>><?php _e('All In One SEO Google Panda Buster 1', 'stallion'); ?></option>
<option value="_aioseop_panda2" <?php if ('_aioseop_panda2' == $instance['aioseolinkpri']) {
echo "selected='selected'";
} ?>><?php _e('All In One SEO Google Panda Buster 2', 'stallion'); ?></option>
<option value="_aioseop_panda3" <?php if ('_aioseop_panda3' == $instance['aioseolinkpri']) {
echo "selected='selected'";
} ?>><?php _e('All In One SEO Google Panda Buster 3', 'stallion'); ?></option>
<option value="_aioseop_panda4" <?php if ('_aioseop_panda4' == $instance['aioseolinkpri']) {
echo "selected='selected'";
} ?>><?php _e('All In One SEO Google Panda Buster 4', 'stallion'); ?></option>
<option value="_aioseop_panda5" <?php if ('_aioseop_panda5' == $instance['aioseolinkpri']) {
echo "selected='selected'";
} ?>><?php _e('All In One SEO Google Panda Buster 5', 'stallion'); ?></option>
<option value="_aioseop_panda6" <?php if ('_aioseop_panda6' == $instance['aioseolinkpri']) {
echo "selected='selected'";
} ?>><?php _e('All In One SEO Google Panda Buster 6', 'stallion'); ?></option>
</select>
</p>

<p>
<input type="checkbox" name="<?php echo $this->get_field_name('showimage'); ?>" value="checked" <?php echo $instance['showimage']; ?> />
<label for="<?php echo $this->get_field_name('showimage'); ?>"><?php _e('Show Thumbnail Image', 'stallion'); ?></label>
</p>

<p>
<label for="<?php echo $this->get_field_id('showimage_ct'); ?>"><?php _e('How Many Links Should Have a Thumbnail Image?', 'stallion') ?></label>
<input class="widefat" id="<?php echo $this->get_field_id('showimage_ct'); ?>" name="<?php echo $this->get_field_name('showimage_ct'); ?>" value="<?php echo $instance['showimage_ct']; ?>" />
<br /><?php _e('If you set the Number of Posts to 5 and want the first two to show an image, set to 2.', 'stallion') ?>
</p>

<p>
<label for="<?php echo $this->get_field_id('randthumbset'); ?>"><?php _e('Random Thumbnails Set', 'stallion') ?></label>
<select id="<?php echo $this->get_field_id('randthumbset'); ?>" name="<?php echo $this->get_field_name('randthumbset'); ?>" class="widefat" style="width:100%;">
<option value="01-default" <?php if ('01-default' == $instance['randthumbset']) {
echo "selected='selected'";
} ?>><?php _e('Default', 'stallion'); ?></option>
<?php if (function_exists('stc_child_thumbs')) { ?><?php $stch_thumbset = stc_child_thumbs();
foreach ($stch_thumbset as $stch_thumbset1 => $stch_thumbset2) {
?>
<option value="<?php echo $stch_thumbset1; ?>" <?php if ($stch_thumbset1 == $instance['randthumbset']) {
echo "selected='selected'";
} ?>><?php echo $stch_thumbset2; ?></option>
<?php } ?><?php } ?>
<option value="custom-01" <?php if ('custom-01' == $instance['randthumbset']) {
echo "selected='selected'";
} ?>><?php _e('Custom 1', 'stallion'); ?></option>
<option value="custom-02" <?php if ('custom-02' == $instance['randthumbset']) {
echo "selected='selected'";
} ?>><?php _e('Custom 2', 'stallion'); ?></option>
<option value="custom-03" <?php if ('custom-03' == $instance['randthumbset']) {
echo "selected='selected'";
} ?>><?php _e('Custom 3', 'stallion'); ?></option>
<option value="custom-04" <?php if ('custom-04' == $instance['randthumbset']) {
echo "selected='selected'";
} ?>><?php _e('Custom 4', 'stallion'); ?></option>
<option value="custom-05" <?php if ('custom-05' == $instance['randthumbset']) {
echo "selected='selected'";
} ?>><?php _e('Custom 5', 'stallion'); ?></option>
<option value="custom-06" <?php if ('custom-06' == $instance['randthumbset']) {
echo "selected='selected'";
} ?>><?php _e('Custom 6', 'stallion'); ?></option>
<option value="custom-07" <?php if ('custom-07' == $instance['randthumbset']) {
echo "selected='selected'";
} ?>><?php _e('Custom 7', 'stallion'); ?></option>
<option value="custom-08" <?php if ('custom-08' == $instance['randthumbset']) {
echo "selected='selected'";
} ?>><?php _e('Custom 8', 'stallion'); ?></option>
<option value="custom-09" <?php if ('custom-09' == $instance['randthumbset']) {
echo "selected='selected'";
} ?>><?php _e('Custom 9', 'stallion'); ?></option>
<option value="custom-10" <?php if ('custom-10' == $instance['randthumbset']) {
echo "selected='selected'";
} ?>><?php _e('Custom 10', 'stallion'); ?></option>
</select>
</p>

<p>
<label for="<?php echo $this->get_field_id('randthumb'); ?>"><?php _e('Number of Random Thumbnails', 'stallion') ?></label>
<input class="widefat" id="<?php echo $this->get_field_id('randthumb'); ?>" name="<?php echo $this->get_field_name('randthumb'); ?>" value="<?php echo $instance['randthumb']; ?>" />
<br /><?php _e('Built in sets include 10 images.', 'stallion') ?>
</p>

<p>
<label for="<?php echo $this->get_field_id('imagetype'); ?>"><?php _e('Image Type', 'stallion') ?></label>
<input class="widefat" id="<?php echo $this->get_field_id('imagetype'); ?>" name="<?php echo $this->get_field_name('imagetype'); ?>" value="<?php echo $instance['imagetype']; ?>" />
<br /><?php _e('Built in sets tend to be jpg.', 'stallion') ?>
</p>

<p>
<label for="<?php echo $this->get_field_id('aioseoaltpri'); ?>"><?php _e('Image Alt Text AIOSEO Priority', 'stallion') ?></label>
<select id="<?php echo $this->get_field_id('aioseoaltpri'); ?>" name="<?php echo $this->get_field_name('aioseoaltpri'); ?>" class="widefat" style="width:100%;">
<option value="_aioseop_none" <?php if ('_aioseop_none' == $instance['aioseoaltpri']) {
echo "selected='selected'";
} ?>><?php _e('Original Post Title Tag', 'stallion'); ?></option>
<option value="_aioseop_title" <?php if ('_aioseop_title' == $instance['aioseoaltpri']) {
echo "selected='selected'";
} ?>><?php _e('All In One SEO or Yoast SEO Title Tag', 'stallion'); ?></option>
<option value="_aioseop_kw_1" <?php if ('_aioseop_kw_1' == $instance['aioseoaltpri']) {
echo "selected='selected'";
} ?>><?php _e('All In One SEO Related Keyphrase 1', 'stallion'); ?></option>
<option value="_aioseop_kw_2" <?php if ('_aioseop_kw_2' == $instance['aioseoaltpri']) {
echo "selected='selected'";
} ?>><?php _e('All In One SEO Related Keyphrase 2', 'stallion'); ?></option>
<option value="_aioseop_kw_3" <?php if ('_aioseop_kw_3' == $instance['aioseoaltpri']) {
echo "selected='selected'";
} ?>><?php _e('All In One SEO Related Keyphrase 3', 'stallion'); ?></option>
<option value="_aioseop_kw_4" <?php if ('_aioseop_kw_4' == $instance['aioseoaltpri']) {
echo "selected='selected'";
} ?>><?php _e('All In One SEO Related Keyphrase 4', 'stallion'); ?></option>
<option value="_aioseop_panda1" <?php if ('_aioseop_panda1' == $instance['aioseoaltpri']) {
echo "selected='selected'";
} ?>><?php _e('All In One SEO Google Panda Buster 1', 'stallion'); ?></option>
<option value="_aioseop_panda2" <?php if ('_aioseop_panda2' == $instance['aioseoaltpri']) {
echo "selected='selected'";
} ?>><?php _e('All In One SEO Google Panda Buster 2', 'stallion'); ?></option>
<option value="_aioseop_panda3" <?php if ('_aioseop_panda3' == $instance['aioseoaltpri']) {
echo "selected='selected'";
} ?>><?php _e('All In One SEO Google Panda Buster 3', 'stallion'); ?></option>
<option value="_aioseop_panda4" <?php if ('_aioseop_panda4' == $instance['aioseoaltpri']) {
echo "selected='selected'";
} ?>><?php _e('All In One SEO Google Panda Buster 4', 'stallion'); ?></option>
<option value="_aioseop_panda5" <?php if ('_aioseop_panda5' == $instance['aioseoaltpri']) {
echo "selected='selected'";
} ?>><?php _e('All In One SEO Google Panda Buster 5', 'stallion'); ?></option>
<option value="_aioseop_panda6" <?php if ('_aioseop_panda6' == $instance['aioseoaltpri']) {
echo "selected='selected'";
} ?>><?php _e('All In One SEO Google Panda Buster 6', 'stallion'); ?></option>
</select>
</p>

<p>
<label for="<?php echo $this->get_field_id('size'); ?>"><?php _e('Image Width', 'stallion') ?></label>
<input class="widefat" id="<?php echo $this->get_field_id('size'); ?>" name="<?php echo $this->get_field_name('size'); ?>" value="<?php echo $instance['size']; ?>" />
</p>

<p>
<label for="<?php echo $this->get_field_id('size2'); ?>"><?php _e('Image Height', 'stallion') ?></label>
<input class="widefat" id="<?php echo $this->get_field_id('size2'); ?>" name="<?php echo $this->get_field_name('size2'); ?>" value="<?php echo $instance['size2']; ?>" />
</p>

<p>
<label for="<?php echo $this->get_field_id('randthumbqual'); ?>"><?php _e('Image Quality', 'stallion') ?></label>
<input class="widefat" id="<?php echo $this->get_field_id('randthumbqual'); ?>" name="<?php echo $this->get_field_name('randthumbqual'); ?>" value="<?php echo $instance['randthumbqual']; ?>" />
</p>

<p>
<label for="<?php echo $this->get_field_id('align'); ?>"><?php _e('Image Alignment', 'stallion') ?></label>
<select id="<?php echo $this->get_field_id('align'); ?>" name="<?php echo $this->get_field_name('align'); ?>" class="widefat" style="width:100%;">
<option value="left" <?php if ('left' == $instance['align']) {echo "selected='selected'";} ?>><?php _e('Align Left', 'stallion'); ?></option>
<option value="right" <?php if ('right' == $instance['align']) {echo "selected='selected'";} ?>><?php _e('Align Right', 'stallion'); ?></option>
<option value="center" <?php if ('center' == $instance['align']) {echo "selected='selected'";} ?>><?php _e('Align Center', 'stallion'); ?></option>
</select>
</p>

<p>
<input type="checkbox" name="<?php echo $this->get_field_name('showexcerpt'); ?>" value="checked" <?php echo $instance['showexcerpt']; ?> />
<label for="<?php echo $this->get_field_name('showexcerpt'); ?>"><?php _e('Show Excerpt', 'stallion'); ?></label>
</p>

<p>
<label for="<?php echo $this->get_field_id('showexcerpt_ct'); ?>"><?php _e('Number of Excerpts', 'stallion') ?></label>
<input class="widefat" id="<?php echo $this->get_field_id('showexcerpt_ct'); ?>" name="<?php echo $this->get_field_name('showexcerpt_ct'); ?>" value="<?php echo $instance['showexcerpt_ct']; ?>" />
<br /><?php _e('If you set the Number of Posts to 5 and want the first two to show an excerpt, set to 2.', 'stallion') ?>
</p>

<p>
<label for="<?php echo $this->get_field_id( 'showexcerptsz' ); ?>"><?php _e('Number of Excerpt Words', 'stallion') ?></label>
<input class="widefat" id="<?php echo $this->get_field_id( 'showexcerptsz' ); ?>" name="<?php echo $this->get_field_name( 'showexcerptsz' ); ?>" value="<?php echo $instance['showexcerptsz']; ?>" />
</p>

<p>
<label for="<?php echo $this->get_field_id('onlycheck'); ?>"><?php _e('Select Posts From', 'stallion') ?></label>
<select id="<?php echo $this->get_field_id('onlycheck'); ?>" name="<?php echo $this->get_field_name('onlycheck'); ?>" class="widefat" style="width:100%;">
<option value="checked" <?php if ('checked' == $instance['onlycheck']) {echo "selected='selected'";} ?>><?php _e('ALL Categories ', 'stallion'); ?></option>
<option value="siloauto" <?php if ('siloauto' == $instance['onlycheck']) {echo "selected='selected'";} ?>><?php _e('Silo: ONLY Categories the Post Viewed is in', 'stallion'); ?></option>
<option value="siloman" <?php if ('siloman' == $instance['onlycheck']) {echo "selected='selected'";} ?>><?php _e('ONLY Categories Selected Below', 'stallion'); ?></option>
</select>
</p>

<p>See the <a href="http://stallion-theme.co.uk/seo-silo/" target="_blank">SEO Silo Tutorial</a>: Setting to "Silo" results in- When on a blog post only posts in the same categories as the post viewed will be shown. When on a category only posts in that category will be shown. For the rest of the site including the home page, posts from all categories are shown.</p>

<p>
<label for="<?php echo $this->get_field_id('include'); ?>"><?php _e('Show posts from these Categories when "ONLY Categories Selected Below" is set above)', 'stallion'); ?></label> 
<select class="widefat" id="<?php echo $this->get_field_id('include'); ?>" name="<?php echo $this->get_field_name('include'); ?>[]" size="6" multiple="multiple">
<?php foreach ($terms as $term) { ?>
<option value="<?php echo $term->term_id; ?>" <?php echo ( in_array($term->term_id, (array) $instance['include']) ? 'selected="selected"' : '' ); ?>><?php echo $term->name; ?></option><?php } ?>
</select>
</p>
<?php }

} ?>
<?php if (function_exists('st_ads_chck')) {

} else {
echo '<h4>This message suggests you have deleted an important file, try uploading Stallion again.</h4>';
}
?>